(function(){Devices = new Mongo.Collection('devices');

Meteor.methods({
  deviceInsert: function(deviceAttributes) {
    check(Meteor.userId(), String);
    check(deviceAttributes, {
      name: String,
      deviceId: String
    });
    var user = Meteor.user();
    var device = _.extend(deviceAttributes, {
      _user: user._id,
      created: moment().format(),
      sensors: [],
    });
    var deviceId = Devices.insert(device);
    return {
      _id: deviceId
    };
  },
  sensorInsert: function (deviceId, sensorAttributes) {
    check(Meteor.userId(), String);
    check(sensorAttributes, {
      name: String,
      slug: String,
      unit: String,
    });
    var user = Meteor.user();
    var device = Devices.findOne({_id: deviceId, _user: user._id});
    if (device) {
      Devices.update({_id: deviceId, _user: user._id}, {'$addToSet': {sensors: {slug: sensorAttributes.slug, name: sensorAttributes.name, unit: sensorAttributes.unit}}});
      return {
        _id: device._id
      };
    } else {
      throw new Meteor.Error(404, 'Error 404: Not found');
    }
  },
});

})();
