(function(){if (Meteor.isServer) {
  Meteor.methods({
    recordData: function (deviceId, sensorSlug, value) {
      var device = Devices.findOne({deviceId: deviceId, 'sensors.slug': sensorSlug});
      if (device) {
        var key = 'values.' + moment().startOf('minute').valueOf();
        var data = {};
        data[key] = value;
        var report = Reports.findOne({_device: device._id, _sensor: sensorSlug, month: moment().format('MM-YYYY')});
        var result;
        if (report) {
          result = Reports.update({_id: report._id}, {$set: data});
          return result;
        } else {
          var payload = {
            _device: device._id,
            _sensor: sensorSlug,
            _user: device._user,
            month: moment().format('MM-YYYY'),
            monthStamp: Number(moment().startOf('month').valueOf()),
            values: {},
          };
          device.sensors.forEach(function (sensor) {
            if (sensor.slug === sensorSlug) {
              payload.unit = sensor.unit;
              payload.name = sensor.name;
            }
          });
          var newReport = Reports.insert(payload);
          if (newReport) {
            result = Reports.update({_id: newReport}, {$set: data});
          }
          return result;
        }
      } else {
        throw new Meteor.Error(404, 'Error 404: Device not found');
      }
    }
  });
}

})();
